diff --git a/dts/doc/conf_yaml_schema.json b/dts/doc/conf_yaml_schema.json
new file mode 120000
index 0000000000..d89eb81b72
--- /dev/null
+++ b/dts/doc/conf_yaml_schema.json
@@ -0,0 +1 @@
+../framework/config/conf_yaml_schema.json
\ No newline at end of file
diff --git a/dts/doc/framework.config.rst b/dts/doc/framework.config.rst
new file mode 100644
index 0000000000..f765ef0e32
--- /dev/null
+++ b/dts/doc/framework.config.rst
@@ -0,0 +1,12 @@
+config - Configuration Package
+==============================
+
+.. automodule:: framework.config
+   :members:
+   :show-inheritance:
+
+.. toctree::
+   :hidden:
+   :maxdepth: 1
+
+   framework.config.types
diff --git a/dts/doc/framework.config.types.rst b/dts/doc/framework.config.types.rst
new file mode 100644
index 0000000000..5af915b681
--- /dev/null
+++ b/dts/doc/framework.config.types.rst
@@ -0,0 +1,6 @@
+types - Configuration Types
+===========================
+
+.. automodule:: framework.config.types
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.dts.rst b/dts/doc/framework.dts.rst
new file mode 100644
index 0000000000..b1de438887
--- /dev/null
+++ b/dts/doc/framework.dts.rst
@@ -0,0 +1,6 @@
+dts - Testbed Setup and Test Suite Runner
+=========================================
+
+.. automodule:: framework.dts
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.exception.rst b/dts/doc/framework.exception.rst
new file mode 100644
index 0000000000..ad58bd15de
--- /dev/null
+++ b/dts/doc/framework.exception.rst
@@ -0,0 +1,6 @@
+exception - Exceptions
+======================
+
+.. automodule:: framework.exception
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.logger.rst b/dts/doc/framework.logger.rst
new file mode 100644
index 0000000000..3c25b34819
--- /dev/null
+++ b/dts/doc/framework.logger.rst
@@ -0,0 +1,6 @@
+logger - Logging Facility
+=========================
+
+.. automodule:: framework.logger
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.remote_session.interactive_remote_session.rst b/dts/doc/framework.remote_session.interactive_remote_session.rst
new file mode 100644
index 0000000000..35dc5c4b03
--- /dev/null
+++ b/dts/doc/framework.remote_session.interactive_remote_session.rst
@@ -0,0 +1,6 @@
+interactive\_remote\_session - SSH Interactive Remote Session
+=============================================================
+
+.. automodule:: framework.remote_session.interactive_remote_session
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.remote_session.interactive_shell.rst b/dts/doc/framework.remote_session.interactive_shell.rst
new file mode 100644
index 0000000000..8a59db7b6e
--- /dev/null
+++ b/dts/doc/framework.remote_session.interactive_shell.rst
@@ -0,0 +1,6 @@
+interactive\_shell - Base Interactive Remote Shell
+==================================================
+
+.. automodule:: framework.remote_session.interactive_shell
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.remote_session.python_shell.rst b/dts/doc/framework.remote_session.python_shell.rst
new file mode 100644
index 0000000000..a8ec06f281
--- /dev/null
+++ b/dts/doc/framework.remote_session.python_shell.rst
@@ -0,0 +1,6 @@
+python\_shell - Python Interactive Remote Shell
+===============================================
+
+.. automodule:: framework.remote_session.python_shell
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.remote_session.remote_session.rst b/dts/doc/framework.remote_session.remote_session.rst
new file mode 100644
index 0000000000..58b0960d07
--- /dev/null
+++ b/dts/doc/framework.remote_session.remote_session.rst
@@ -0,0 +1,6 @@
+remote\_session - Remote Session ABC
+====================================
+
+.. automodule:: framework.remote_session.remote_session
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.remote_session.rst b/dts/doc/framework.remote_session.rst
new file mode 100644
index 0000000000..74f83f0307
--- /dev/null
+++ b/dts/doc/framework.remote_session.rst
@@ -0,0 +1,17 @@
+remote\_session - Node Connections Package
+==========================================
+
+.. automodule:: framework.remote_session
+   :members:
+   :show-inheritance:
+
+.. toctree::
+   :hidden:
+   :maxdepth: 1
+
+   framework.remote_session.remote_session
+   framework.remote_session.ssh_session
+   framework.remote_session.interactive_remote_session
+   framework.remote_session.interactive_shell
+   framework.remote_session.testpmd_shell
+   framework.remote_session.python_shell
diff --git a/dts/doc/framework.remote_session.ssh_session.rst b/dts/doc/framework.remote_session.ssh_session.rst
new file mode 100644
index 0000000000..05b019bc7c
--- /dev/null
+++ b/dts/doc/framework.remote_session.ssh_session.rst
@@ -0,0 +1,6 @@
+ssh\_session - SSH Remote Session
+=================================
+
+.. automodule:: framework.remote_session.ssh_session
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.remote_session.testpmd_shell.rst b/dts/doc/framework.remote_session.testpmd_shell.rst
new file mode 100644
index 0000000000..14510afb2b
--- /dev/null
+++ b/dts/doc/framework.remote_session.testpmd_shell.rst
@@ -0,0 +1,6 @@
+testpmd\_shell - Testpmd Interactive Remote Shell
+=================================================
+
+.. automodule:: framework.remote_session.testpmd_shell
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.rst b/dts/doc/framework.rst
new file mode 100644
index 0000000000..978d5b5e38
--- /dev/null
+++ b/dts/doc/framework.rst
@@ -0,0 +1,30 @@
+framework - DTS Libraries
+=========================
+
+.. automodule:: framework
+   :members:
+   :show-inheritance:
+
+Packages
+--------
+
+.. toctree::
+   :maxdepth: 3
+
+   framework.config
+   framework.remote_session
+   framework.testbed_model
+
+Modules
+-------
+
+.. toctree::
+   :maxdepth: 1
+
+   framework.dts
+   framework.exception
+   framework.logger
+   framework.settings
+   framework.test_result
+   framework.test_suite
+   framework.utils
diff --git a/dts/doc/framework.settings.rst b/dts/doc/framework.settings.rst
new file mode 100644
index 0000000000..96bf194923
--- /dev/null
+++ b/dts/doc/framework.settings.rst
@@ -0,0 +1,6 @@
+settings - Command Line Arguments and Environment Variables
+===========================================================
+
+.. automodule:: framework.settings
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.test_result.rst b/dts/doc/framework.test_result.rst
new file mode 100644
index 0000000000..527357a04a
--- /dev/null
+++ b/dts/doc/framework.test_result.rst
@@ -0,0 +1,6 @@
+test\_result - Test Results Records
+===================================
+
+.. automodule:: framework.test_result
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.test_suite.rst b/dts/doc/framework.test_suite.rst
new file mode 100644
index 0000000000..96f893e465
--- /dev/null
+++ b/dts/doc/framework.test_suite.rst
@@ -0,0 +1,6 @@
+test\_suite - Common Test Suite Features
+========================================
+
+.. automodule:: framework.test_suite
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.cpu.rst b/dts/doc/framework.testbed_model.cpu.rst
new file mode 100644
index 0000000000..dd2baf09fb
--- /dev/null
+++ b/dts/doc/framework.testbed_model.cpu.rst
@@ -0,0 +1,6 @@
+cpu - CPU Representation and Utilities
+======================================
+
+.. automodule:: framework.testbed_model.cpu
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.linux_session.rst b/dts/doc/framework.testbed_model.linux_session.rst
new file mode 100644
index 0000000000..141f3f49e3
--- /dev/null
+++ b/dts/doc/framework.testbed_model.linux_session.rst
@@ -0,0 +1,6 @@
+linux\_session - Linux Remote Session
+=====================================
+
+.. automodule:: framework.testbed_model.linux_session
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.node.rst b/dts/doc/framework.testbed_model.node.rst
new file mode 100644
index 0000000000..2133dd604b
--- /dev/null
+++ b/dts/doc/framework.testbed_model.node.rst
@@ -0,0 +1,6 @@
+node - Base Node
+================
+
+.. automodule:: framework.testbed_model.node
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.os_session.rst b/dts/doc/framework.testbed_model.os_session.rst
new file mode 100644
index 0000000000..f3574e939a
--- /dev/null
+++ b/dts/doc/framework.testbed_model.os_session.rst
@@ -0,0 +1,6 @@
+os\_session - OS-aware Remote Session ABC
+=========================================
+
+.. automodule:: framework.testbed_model.os_session
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.port.rst b/dts/doc/framework.testbed_model.port.rst
new file mode 100644
index 0000000000..17bd391e63
--- /dev/null
+++ b/dts/doc/framework.testbed_model.port.rst
@@ -0,0 +1,6 @@
+port - NIC Port Representation
+==============================
+
+.. automodule:: framework.testbed_model.port
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.posix_session.rst b/dts/doc/framework.testbed_model.posix_session.rst
new file mode 100644
index 0000000000..308c051ae5
--- /dev/null
+++ b/dts/doc/framework.testbed_model.posix_session.rst
@@ -0,0 +1,6 @@
+posix\_session - Posix Remote Session
+=====================================
+
+.. automodule:: framework.testbed_model.posix_session
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.rst b/dts/doc/framework.testbed_model.rst
new file mode 100644
index 0000000000..4b024e47e6
--- /dev/null
+++ b/dts/doc/framework.testbed_model.rst
@@ -0,0 +1,26 @@
+testbed\_model - Testbed Modelling Package
+==========================================
+
+.. automodule:: framework.testbed_model
+   :members:
+   :show-inheritance:
+
+.. toctree::
+   :hidden:
+   :maxdepth: 2
+
+   framework.testbed_model.traffic_generator
+
+.. toctree::
+   :hidden:
+   :maxdepth: 1
+
+   framework.testbed_model.os_session
+   framework.testbed_model.linux_session
+   framework.testbed_model.posix_session
+   framework.testbed_model.node
+   framework.testbed_model.sut_node
+   framework.testbed_model.tg_node
+   framework.testbed_model.cpu
+   framework.testbed_model.port
+   framework.testbed_model.virtual_device
diff --git a/dts/doc/framework.testbed_model.sut_node.rst b/dts/doc/framework.testbed_model.sut_node.rst
new file mode 100644
index 0000000000..7e12b6c87e
--- /dev/null
+++ b/dts/doc/framework.testbed_model.sut_node.rst
@@ -0,0 +1,6 @@
+sut\_node - System Under Test Node
+==================================
+
+.. automodule:: framework.testbed_model.sut_node
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.tg_node.rst b/dts/doc/framework.testbed_model.tg_node.rst
new file mode 100644
index 0000000000..41206c000b
--- /dev/null
+++ b/dts/doc/framework.testbed_model.tg_node.rst
@@ -0,0 +1,6 @@
+tg\_node - Traffig Generator Node
+=================================
+
+.. automodule:: framework.testbed_model.tg_node
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.traffic_generator.capturing_traffic_generator.rst b/dts/doc/framework.testbed_model.traffic_generator.capturing_traffic_generator.rst
new file mode 100644
index 0000000000..06c087155a
--- /dev/null
+++ b/dts/doc/framework.testbed_model.traffic_generator.capturing_traffic_generator.rst
@@ -0,0 +1,6 @@
+capturing\_traffic\_generator - Base Capturing TG ABC
+=====================================================
+
+.. automodule:: framework.testbed_model.traffic_generator.capturing_traffic_generator
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.traffic_generator.rst b/dts/doc/framework.testbed_model.traffic_generator.rst
new file mode 100644
index 0000000000..18b6f1b98b
--- /dev/null
+++ b/dts/doc/framework.testbed_model.traffic_generator.rst
@@ -0,0 +1,14 @@
+traffic\_generator Subpackage
+=============================
+
+.. automodule:: framework.testbed_model.traffic_generator
+   :members:
+   :show-inheritance:
+
+.. toctree::
+   :hidden:
+   :maxdepth: 1
+
+   framework.testbed_model.traffic_generator.traffic_generator
+   framework.testbed_model.traffic_generator.capturing_traffic_generator
+   framework.testbed_model.traffic_generator.scapy
diff --git a/dts/doc/framework.testbed_model.traffic_generator.scapy.rst b/dts/doc/framework.testbed_model.traffic_generator.scapy.rst
new file mode 100644
index 0000000000..7062914ec3
--- /dev/null
+++ b/dts/doc/framework.testbed_model.traffic_generator.scapy.rst
@@ -0,0 +1,6 @@
+scapy - Capturing Traffic Generator
+===================================
+
+.. automodule:: framework.testbed_model.traffic_generator.scapy
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.traffic_generator.traffic_generator.rst b/dts/doc/framework.testbed_model.traffic_generator.traffic_generator.rst
new file mode 100644
index 0000000000..e366d7f222
--- /dev/null
+++ b/dts/doc/framework.testbed_model.traffic_generator.traffic_generator.rst
@@ -0,0 +1,6 @@
+traffic\_generator - Base TG ABC
+================================
+
+.. automodule:: framework.testbed_model.traffic_generator.traffic_generator
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.testbed_model.virtual_device.rst b/dts/doc/framework.testbed_model.virtual_device.rst
new file mode 100644
index 0000000000..38e6c1d0bc
--- /dev/null
+++ b/dts/doc/framework.testbed_model.virtual_device.rst
@@ -0,0 +1,6 @@
+virtual\_device - Virtual Devices
+=================================
+
+.. automodule:: framework.testbed_model.virtual_device
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/framework.utils.rst b/dts/doc/framework.utils.rst
new file mode 100644
index 0000000000..0e7bb80666
--- /dev/null
+++ b/dts/doc/framework.utils.rst
@@ -0,0 +1,6 @@
+utils - Various Utilities
+=========================
+
+.. automodule:: framework.utils
+   :members:
+   :show-inheritance:
diff --git a/dts/doc/index.rst b/dts/doc/index.rst
new file mode 100644
index 0000000000..fc3b6d78b9
--- /dev/null
+++ b/dts/doc/index.rst
@@ -0,0 +1,41 @@
+.. DPDK Test Suite documentation.
+
+Welcome to DPDK Test Suite's API documentation!
+===============================================
+
+.. automodule:: framework
+   :members:
+   :show-inheritance:
+
+Packages
+--------
+
+.. toctree::
+   :includehidden:
+   :maxdepth: 1
+
+   framework.config
+   framework.remote_session
+   framework.testbed_model
+
+Modules
+-------
+
+.. toctree::
+   :maxdepth: 1
+
+   framework.dts
+   framework.exception
+   framework.logger
+   framework.settings
+   framework.test_result
+   framework.test_suite
+   framework.utils
+
+
+Indices and tables
+==================
+
+* :ref:`genindex`
+* :ref:`modindex`
+* :ref:`search`